solution "gmsv_quickhull"

	language "C++"
	location ( os.get() .."-".. _ACTION )
	flags { "Symbols", "NoEditAndContinue", "NoPCH", "StaticRuntime", "EnableSSE" }
	targetdir ( "lib/" .. os.get() .. "/" )
	includedirs { "../include/" }
	
	configurations
	{ 
		"Release",
		"Debug"
	}
	
	configuration "Release"
		defines { "NDEBUG" }
		flags{ "Optimize", "FloatFast" }

	configuration "Debug"
		defines { "YDEBUG" }
		flags{ "Symbols" }

	project "gmsv_quickhull"
		defines { "GMMODULE" }
		files { "src/**.*" }
		links {"quickhull", "mesh-subdivision"}
		kind "SharedLib"

	project "quickhull"
		kind "StaticLib"
		files {"../include/quickhull/QuickHull.cpp"}
		if os.get() == "linux" then buildoptions { "-fPIC" } end

	mesh_subdivision_root = "../include/mesh-subdivision/MeshSubdivision/"
	project "mesh-subdivision"
		kind "StaticLib"
		includedirs {mesh_subdivision_root}
		files {
			mesh_subdivision_root .. "Point.cpp",
			mesh_subdivision_root .. "Mesh.cpp",
			mesh_subdivision_root .. "MeshData.cpp",
			mesh_subdivision_root .. "Loop.cpp",
			mesh_subdivision_root .. "CatmullClark.cpp",
			mesh_subdivision_root .. "DooSabin.cpp",
			mesh_subdivision_root .. "PetersReiff.cpp",
			mesh_subdivision_root .. "Butterfly.cpp",
			mesh_subdivision_root .. "KobbeltRoot3.cpp"
		}
		if os.get() == "linux" then buildoptions { "-fPIC" } end
